import Foundation

public class RealtimeSubscription {
    public var close: () -> Void

    init(close: @escaping () -> Void) {
        self.close = close
    }
}

public class RealtimeCallback {
    public let channels: Set<String>
    public let callback: (RealtimeResponseEvent) -> Void

    init(
        for channels: Set<String>,
        and callback: @escaping (RealtimeResponseEvent) -> Void
    ) {
        self.channels = channels
        self.callback = callback
    }
}

public class RealtimeResponseEvent {
    public let events: [String]?
    public let channels: [String]?
    public let timestamp: Int64?
    public var payload: [String: Any]?

    init(
        events: [String],
        channels: [String],
        timestamp: Int64,
        payload: [String: Any]
    ) {
        self.events = events
        self.channels = channels
        self.timestamp = timestamp
        self.payload = payload
    }
}
